// trieda pre pracu s OpenGL kamerou
class mCamera {
public:
 mCamera();          // konstruktor
 virtual ~mCamera(); // destruktor

 // reset pohladu kamery
 void cam_reset(void);
 // reset casu
 void cam_resettime(void);
 // reinicializacia kamery
 void cam_reinit(GLfloat w,GLfloat h);
 // aktualizacia nastaveni kamery
 void cam_update(void);
 // posun kamery
 void cam_move(void);
 // rotacia kamery
 void cam_rotate(GLfloat x,GLfloat y,GLfloat z);
 // zap/vyp detekcie kolizii
 void CollisionOnOff(void);

 GLfloat scr_w,scr_h; // sirka, vyska okna

 GLfloat matrix[16];                             // matica kamery
 GLfloat posx,posy,posz,movx,movy,movz;          // poloha, posun
 GLfloat oldx,oldy,oldz;                         // povodna poloha
 GLfloat targetx,targety,targetz;                // smer
 // indikatory pre vykonavanie definovanych posunov kamery
 GLubyte goForward,goBack,goUp,goDown,goRight,goLeft,goFast;
 GLubyte goJump; // skok

 GLubyte isFire1; // strelba1 (lave tlacidlo mysi)
 GLubyte isFire2; // strelba2 (prave tlacidlo mysi)

 GLubyte movetype; // typ pohybu

 GLfloat ogl_fps; // pocitadlo FPS (snimky za sekundu)

 // detekcia kolizie kamery s objektom sceny (trojuholnikom)
 int cam_collision(GLfloat x1,GLfloat y1,GLfloat z1,
	               GLfloat x2,GLfloat y2,GLfloat z2,
	               GLfloat x3,GLfloat y3,GLfloat z3,
                   GLfloat tr_nx,GLfloat tr_ny,GLfloat tr_nz,
                   GLfloat tr_cn1,GLfloat tr_cn2, GLfloat tr_cn3, GLfloat tr_cn4,
                   GLfloat tr_cn5,GLfloat tr_cn6, GLfloat tr_cn7, GLfloat tr_cn8,
                   GLfloat tr_cn9,GLfloat tr_cn10,GLfloat tr_cn11,GLfloat tr_cn12);	  
 // indikator zap/vyp dektekcie kolizii
 GLubyte collision_onoff;
 // nastala/nenastala kolizia
 GLubyte is_collision;
private:
 GLfloat angx,angy,angz,rotx,roty,rotz;          // otocenie, rotacia
 GLfloat speed,slide,alt;                        // rychlost, bocny pohyb, zmena vysky
 GLfloat acceleration,gravity;                   // zrychlenie, gravitacne zrychlenie
 GLfloat viewdist;                               // maximalny dohlad
 GLfloat FOV;                                    // uhol pohladu
 GLfloat JumpPower;                              // sila skoku

 GLfloat go_x,go_y,go_z;                         // prepocet pre posun (movx,movy,movz)

 GLfloat rotx_factor,roty_factor,rotz_factor;    // konstanty pre upravu rychlosti rotacie
 GLfloat movx_factor,movy_factor,movz_factor;    // konstanty pre upravu rychlosti posunu

 GLuint t_a,t_b; // pomocne premenne

 // ulozenie stareho a noveho casoveho okamihu (ms)
 GLuint oldTime,actTime;
 // cas vykreslenia sceny
 GLfloat difTime;
 // cas posobenia gravitacie
 GLfloat gravityTime;
 // pocitadlo pre FPS (pocet snimkov)
 GLfloat ogl_frames;
};
