// trieda premennych a funkcii pre Frustum Culling
class FrustumCulling {
public:
 FrustumCulling();          // konstruktor
 virtual ~FrustumCulling(); // destruktor

 // funkcia pre vypocet Frustum
 void FrustumUpdate(void);

 // test, ci je bod vo Frustum x, y, z - 3D suradnice bodu
 bool PointInFrustum(GLfloat x,GLfloat y,GLfloat z);
 // test, ci je trojuholnik vo Frustum
 bool TriangleInFrustum(GLfloat v1,GLfloat v2,GLfloat v3,
                        GLfloat v4,GLfloat v5,GLfloat v6,
                        GLfloat v7,GLfloat v8,GLfloat v9);
 // test, ci je gula vo Frustum x, y, z - stred gule, radius - polomer
 bool SphereInFrustum(GLfloat x,GLfloat y,GLfloat z,GLfloat radius);
 // test, ci je kocka vo Frustum x, y, z - stred kocky, size - 1/2 velkosti
 bool CubeInFrustum(GLfloat x,GLfloat y,GLfloat z,GLfloat size);
 // test, ci je kocka vo Frustum x, y, z - min. a max. hodnoty v danych smeroch
 bool CubeInFrustum2(GLfloat x1,GLfloat x2,
                     GLfloat y1,GLfloat y2,
                     GLfloat z1,GLfloat z2);
private:
 // ulozenie A, B, C, D hodnot kazdej rezovej roviny Frustum
 GLfloat m_Frustum[6][4];

 GLfloat magnitude; // velkost normaly

 // normalizacia strany Frustum
 void NormalizePlane(GLfloat frustum[6][4],GLuint side);

 GLfloat proj[16]; // nacitanie projekcnej matice
 GLfloat modl[16]; // nacitanie modelview matice
 GLfloat clip[16]; // vypocet orezavecich rovin

 GLuint i; // pomocna premenna
};

/*
  tento kod vznikol po uprave zverejneneho kodu autora:

  Ben Humphrey (DigiBen)
  Game Programmer
  DigiBen@GameTutorials.com
  Co-Web Host of www.GameTutorials.com
  date: 11/26/01
*/
