// hlavickove subory *******************************************************
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mTexture.h"

// konstruktor *************************************************************
mTexture::mTexture()
{
 texture_id[0]=0;

 crosshair_tex_id=0;
}

// destruktor **************************************************************
mTexture::~mTexture()
{

}

// nahratie textury ********************************************************
int mTexture::LoadTexture(GLuint id,char *myfile)
{
 // alokovanie miesta pre data textury
 SDL_Surface *TextureImage;

 TextureImage=SDL_LoadBMP(myfile);

 // nahratie suboru s bitmapou
 if (TextureImage!=NULL) {
  glGenTextures(1,&texture_id[id]);
  // pripojenie textury
  glBindTexture(GL_TEXTURE_2D,texture_id[id]);
  // nastavenie LINEAR filteringu
  //glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  //glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
  // vygenerovanie textury
  gluBuild2DMipmaps(GL_TEXTURE_2D,3,TextureImage->w,TextureImage->h,
                    GL_BGR,GL_UNSIGNED_BYTE,TextureImage->pixels);
	 
  // vygenerovanie textury
  //glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage->w,TextureImage->h,
  //             0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage->pixels);
 }
 else return(1);

 // uvolnenie pouzitej pamate
 if (TextureImage) SDL_FreeSurface(TextureImage);

 return(0);
}

// nahratie textury zameriavacieho kriza ***********************************
int mTexture::LoadCrosshairTexture(char *myfile)
{
 // alokovanie miesta pre data textury
 SDL_Surface *TextureImage[1];

 // nahratie suboru s bitmapou
 if ((TextureImage[0]=SDL_LoadBMP(myfile))) {
  glGenTextures(1,&crosshair_tex_id);
  // pripojenie textury
  glBindTexture(GL_TEXTURE_2D,crosshair_tex_id);
  // nastavenie LINEAR filteringu
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  // vygenerovanie textury
  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[0]->w,TextureImage[0]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[0]->pixels);
 }
 else return(1);

 // uvolnenie pouzitej pamate
 if (TextureImage[0]) SDL_FreeSurface(TextureImage[0]);

 return(0);
}

// vykreslenie zameriavacieho kriza ****************************************
int mTexture::DrawCrosshair(GLfloat w,GLfloat h)
{
 // ulozenie potrebnych atributov
 glPushAttrib(GL_DEPTH_BUFFER_BIT|GL_TEXTURE_BIT);
 glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
 glEnable(GL_TEXTURE_2D);  // zapnutie texturovania

 glBlendFunc(GL_ONE,GL_ONE); // zapnutie priesvitnosti
 glEnable(GL_BLEND);

 glMatrixMode(GL_PROJECTION); // uprava projekcnej matice
 glPushMatrix();
 glLoadIdentity();
 glOrtho(0.0f,w,0.0f,h,-1.0f,1.0f); // pravouhly suradnicovy system
 glMatrixMode(GL_MODELVIEW);  // uprava pohladovej matice
 glPushMatrix();
 glLoadIdentity();

 // zameriavaci kriz na stred okna
 glTranslatef(w/2.0f,h/2.0f,0.0f);
 // pripojenie textury zameriavacieho kriza
 glBindTexture(GL_TEXTURE_2D,crosshair_tex_id);
 // stvoruholnik
 glBegin(GL_QUADS);
  glTexCoord2f(0.0f,0.0f); glVertex3f(-32.0f,-32.0f,0.0f);
  glTexCoord2f(1.0f,0.0f); glVertex3f( 32.0f,-32.0f,0.0f);
  glTexCoord2f(1.0f,1.0f); glVertex3f( 32.0f, 32.0f,0.0f);
  glTexCoord2f(0.0f,1.0f); glVertex3f(-32.0f, 32.0f,0.0f);
 glEnd();

 glDisable(GL_BLEND); // vypnutie priesvitnosti

 glPopMatrix(); // pohladova
 glMatrixMode(GL_PROJECTION);
 glPopMatrix(); // projekcna
 glMatrixMode(GL_MODELVIEW); // aktualna je vzdy pohladova

 glPopAttrib(); // vyber ulozenych atributov

 return(0);
}
